% dicom indexing. Script that goes through all files in a folder, reads the
% dicom info, and creates a folder structure based on series description.
%
% written by CTCIC 5/1/2021
% updated by CTCIC 7/2/2021 for VIACLIN/SCANNER EID output
% Note: May need to be altered to properly sort special cases

clear all
close all
fclose('all')
clc

% addpath(genpath('\\mfad.mfroot.org\rchdept\Radiology\Groups\CT CIC\CIC Staff Folders\Ferrero, Andrea\code\'));

work_dir = pwd;

file_list = recursiveFindFile(work_dir, '*');
file_list = file_list(1:size(file_list)-1);

% n = str2num(getenv('NUMBER_OF_PROCESSORS'));
%     
%     if isempty(gcp('nocreate'))
%         parpool(n-1);
%     end

for ff=1:numel(file_list)
    cur_file = file_list{ff};
    [path, name, ext] = fileparts(cur_file);
    if ~isdicom(cur_file)
        continue;
    end
    hdr = dicominfo(cur_file);
    if ~isfield(hdr, 'SeriesNumber') || ~isfield(hdr, 'AcquisitionNumber')
        continue;
    end
    %hdr.ConvolutionKernel(strfind(hdr.ConvolutionKernel, '\')) = '-';
    %new_path = [work_dir '\sorted\' num2str(hdr.SeriesNumber) '_' hdr.SeriesDescription '_CTDI' num2str(round(hdr.CTDIvol)) '_' hdr.ConvolutionKernel '\'];

    new_path = [work_dir '\sorted\' num2str(hdr.SeriesNumber) '_' num2str(hdr.AcquisitionNumber) '\'];
    if strcmp([path '\'], new_path)
        continue;
    end
    if ~isfolder(new_path)
        mkdir(new_path);
    end
    movefile(cur_file, [new_path name ext]);
end


    